<?php
ini_set('display_errors', 1);

require_once '../../../../resources/base_path_include.php';

require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'functions/common_functions.php';
//db access function
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';

//aws image store
require_once $base_path_to_learning_resources . 'lib/bucket_functions/bucket_functions.php';
require_once $base_path_to_learning . "vendor/autoload.php";

require_once $base_path_to_learning_resources . 'includes/aws_bucket_config.php';

use Aws\S3\S3Client;
use Aws\S3\Exception\S3Exception;

$postdata = json_decode(file_get_contents("php://input"), true);
// print_r($postdata);
checkIfNoPhpContentsReceive();

if (
    // !isset($postdata['institution_id']) or !checkIfIssetAndNotEmpty($postdata['institution_id']) or

    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type'])  or
    !isset($postdata['jwt_token']) or  !checkIfIssetAndNotEmpty($postdata['jwt_token'])
) {
    errorreturn("All * fields are required.");
}
validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;
$branch_id = $jwt_validate->data->branch_id;
$institution_id = $jwt_validate->data->institution_id;

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id, null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}

function getvendor($conn_rjllearning_specific, $institution_id, $search_string, $branch_id,$limit, $offset)
{
    $sql = "SELECT  count(*) as total_rows FROM  vendor where institution_id =?";
    $array_params = [$institution_id];

    $stmt = $conn_rjllearning_specific->prepare($sql);
    $stmt->execute($array_params);
    $result_total = $stmt->fetchAll();
    $totalrows = $result_total[0]['total_rows'];

    if ($limit == 'all') {

        $sql_session = "SELECT * FROM  vendor  where institution_id =? and vendor_name LIKE ? and vendor_service LIKE ?";
        $array_params = [$institution_id, '%' . $search_string . '%', '%' . $search_string . '%'];
        if ($branch_id == 'all') {
            $sql_session .= "";
        } else if ($branch_id !=  null  && $branch_id != 'all') {
            $sql_session .= " AND branch_id = ? ";
            $array_params[] = $branch_id;
        }

        if ($search_string != null) {
            $sql_session .= " AND vendor_name LIKE ? ";
            $array_params[] = '%' . $search_string . '%'; // Append to $array_params
        }
        
        
      $sql_session .=  "order by date_created desc, time_created desc";
        
        
    } else {
        $sql_session = "SELECT * FROM vendor WHERE institution_id = ?";
        $array_params = [$institution_id];
        
        if ($branch_id == 'all') {
            $sql_session .= "";
        } else if ($branch_id !=  null  && $branch_id != 'all') {
            $sql_session .= " AND branch_id = ? ";
            $array_params[] = $branch_id;
        }

        if ($search_string != null) {
            $sql_session .= " AND vendor_name LIKE ? ";
            $array_params[] = '%' . $search_string . '%'; // Append to $array_params
        }

      $sql_session .= " order by date_created desc, time_created desc ";
      $sql_session .= "LIMIT " . $offset . " ," . $limit . "";
    }
    $stmt = $conn_rjllearning_specific->prepare($sql_session);
    $stmt->execute($array_params);
    $session_rows = $stmt->fetchAll();
    
    

    $array_return = [];

    foreach ($session_rows as $rows) {

        $branch_info = getBranchInfo($conn_rjllearning_specific, $institution_id, $rows['branch_id']);
        $array_return[] = array('vendor_id' => $rows['id'], 
        'branch_id' => $branch_info,
        'vendor_name' => $rows['vendor_name'], 
         'institution_id' => $rows['institution_id'],
        'vendor_service' => $rows['vendor_service'],
         'contact_number' => $rows['contact_number'],
          'email' => $rows['email'],
           'address' => $rows['address'],
            'pincode' => $rows['pincode'],
             'pan' => $rows['pan'],
           'gst' => $rows['gst'],
            'created_by' => $rows['created_by'],
               'time_created' => $rows['time_created'],
                 'date_created'=>$rows['date_created']);
    }

    if (count($session_rows) < 50) {

        return array('total_rows' => $totalrows, 'vendor_info' => $array_return, 'maxreach' => 1);
    } else {
        return array('total_rows' => $totalrows, 'vendor_info' => $array_return, 'maxreach' => 0);
    }
}


if ($postdata['function_type'] == "fetch_vendor") {
    
    // $institution_id = trim($postdata['institution_id']);
    
    $check_academic_confirmation = CheckAcademicSession($conn_rjllearning_specific, $institution_id);
    if ($check_academic_confirmation != true) {
        errorreturn("Access denied. Academic session not active.");
    }
    // if(isset($postdata['branch_id']) and !empty($postdata['branch_id']) and trim($postdata['branch_id'])) {
    //     $branch_id = trim($postdata['branch_id']);
    // } else {
    //     $branch_id = null;
    // }


   
    if (isset($postdata['search_string']) and !empty($postdata['search_string'])) {
        $search_string = trim($postdata['search_string']);
    } else {
        $search_string = null;
    }

    $limit = $postdata['limit'];

    $page = (isset($postdata['page']) and isNumeric($postdata['page'])) ? (int)$postdata['page'] : 1;

    if ($limit != 'all') {
        $offset = ($page - 1) * $limit;
        $success['data'] = getvendor($conn_rjllearning_specific, $institution_id, $search_string, $branch_id,$limit, $offset);
        successreturn($success);
    } else {
        $success['data'] = getvendor($conn_rjllearning_specific, $institution_id, $search_string, $branch_id,$limit, null);
        successreturn($success);
    }
}
